
local ADDON_NAME, namespace = ...
local L = namespace.L
local loaded, moving = false, false
local BB_BuffList, BB_DebuffList = {}, {}

function BuffBuddy_Initialize()
---------------------------------------------------------------------------------------------------------------------------------
function BuffBuddy_GetBuffs()
local debuffs, buffs = {}, {}
-----------------------------------------------
for idx = 1, BUFF_MAX_DISPLAY do
local spellid = select(11, UnitAura("player", idx, "HELPFUL"))
if spellid ~= nil then
table.insert(buffs, {index = idx, spellid = spellid})
else 
break 
end
end
-----------------------------------------------
for idx = 1, DEBUFF_MAX_DISPLAY do 
local spellid = select(11, UnitAura("player", idx, "HARMFUL"))

if spellid ~= nil then
table.insert(debuffs, {index = idx, spellid = spellid})
else 
break 
end

end
-----------------------------------------------
BuffBuddy_SortBuffs(buffs, debuffs)
end

function BuffBuddy_SortBuffs(buffs, debuffs)
local bufflist = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.buffprioritylist
local debufflist = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.debuffprioritylist
BB_BuffList, BB_DebuffList = {}, {} --Reset Buff/Debuff tables
-----------------------------
if #bufflist ~= 0 then
for idx = 1, #bufflist do
local index = idx
for idx = 1, #buffs do
if buffs[idx].spellid == bufflist[index].spellid then
table.insert(BB_BuffList, buffs[idx].index)
table.remove(buffs, idx)
break
end
end
end
end
-----------------------------
if #debufflist ~= 0 then
for idx = 1, #debufflist do
local index = idx
for idx = 1, #debuffs do
if debuffs[idx].spellid == debufflist[index].spellid then
table.insert(BB_DebuffList, debuffs[idx].index)
table.remove(debuffs, idx)
break
end
end
end
end

--fill the tables with remaining buffs/debuffs
if #buffs ~= 0 then
for idx = 1, #buffs do
table.insert(BB_BuffList, buffs[idx].index)
end
elseif #BB_BuffList == 0 then
table.insert(BB_BuffList, 1)
end

if #debuffs ~= 0 then
for idx = 1, #debuffs do
table.insert(BB_DebuffList, debuffs[idx].index)
end
elseif #BB_DebuffList == 0 then
table.insert(BB_DebuffList, 1)
end
-----------------------------
end


--Replacement for default UI function
function BuffFrame_Update(move) 

BuffBuddy_GetBuffs()
if move == true then
for idx = 1, BUFF_MAX_DISPLAY do
table.insert(BB_BuffList, 1)
end
for idx = 1, DEBUFF_MAX_DISPLAY do
table.insert(BB_DebuffList, 1)
end
end
    -- Handle Buffs
    BUFF_ACTUAL_DISPLAY = 0;
    for idx = 1, #BB_BuffList do
        if ( AuraButton_Update("BuffButton", BB_BuffList[idx], "HELPFUL", idx, move) ) then
            BUFF_ACTUAL_DISPLAY = BUFF_ACTUAL_DISPLAY + 1;
        end
		
    end
     
    -- Handle debuffs
    DEBUFF_ACTUAL_DISPLAY = 0;
    for idx = 1, #BB_DebuffList do
        if ( AuraButton_Update("DebuffButton", BB_DebuffList[idx], "HARMFUL", idx, move) ) then
            DEBUFF_ACTUAL_DISPLAY = DEBUFF_ACTUAL_DISPLAY + 1;
        end
    end
for idx = (#BB_BuffList + 1), BUFF_MAX_DISPLAY + 1 do
if ( _G["BuffButton"..idx] ) then
_G["BuffButton"..idx]:Hide();
_G["BuffButton"..idx].duration:Hide();
end
end

for idx = (#BB_DebuffList + 1), DEBUFF_MAX_DISPLAY + 1 do
if ( _G["DebuffButton"..idx] ) then
_G["DebuffButton"..idx]:Hide();
_G["DebuffButton"..idx].duration:Hide();
end
end

BuffBuddy_UpdateAnchors()
    RaidBuffTray_Update();
end

--Replacement for default UI function (just to change a couple of variables
function AuraButton_Update(buttonName, index, filter, idx, move)
    local unit = PlayerFrame.unit;
    local name, rank, texture, count, debuffType, duration, expirationTime, _, _, shouldConsolidate, spellId = UnitAura(unit, index, filter);
	local buffName = buttonName..idx;
    local buff = _G[buffName];
	
if move == true then
if filter == "HARMFUL" then
name = "dummy"
duration = 120
expirationTime = GetTime() + 120
count = 1
texture = select(3, GetSpellInfo(15007))
elseif filter == "HELPFUL" then
name = "dummy"
duration = 120
expirationTime = GetTime() + 120
count = 1
texture = select(3, GetSpellInfo(59620))
end
end
     
    if ( not name ) then
        -- No buff so hide it if it exists
        if ( buff ) then
            buff:Hide();
            buff.duration:Hide();
        end
        return nil;
    else
        local helpful = (filter == "HELPFUL");
 
        -- If button doesn't exist make it
        if ( not buff ) then
            if ( helpful ) then
                buff = CreateFrame("Button", buffName, BBBuffFrame, "BuffButtonTemplate");
            else
                buff = CreateFrame("Button", buffName, BBDebuffFrame, "DebuffButtonTemplate");
            end
            buff.parent = BBBuffFrame;
        end
        -- Setup Buff
        buff:SetID(index);
        buff.unit = unit;
        buff.filter = filter;
        buff:SetAlpha(1.0);
        buff.exitTime = nil;
        buff.consolidated = nil;
        buff:Show();
		local aura = UnitAura
        -- Set filter-specific attributes
        if ( not helpful ) then
		aura = UnitDebuff
            -- Set color of debuff border based on dispel class.
            local debuffSlot = _G[buffName.."Border"];
            if ( debuffSlot ) then
                local color;
                if ( debuffType ) then
                    color = DebuffTypeColor[debuffType];
                    if ( ENABLE_COLORBLIND_MODE == "1" ) then
                        buff.symbol:Show();
                        buff.symbol:SetText(DebuffTypeSymbol[debuffType] or "");
                    else
                        buff.symbol:Hide();
                    end
                else
                    buff.symbol:Hide();
                    color = DebuffTypeColor["none"];
                end
                debuffSlot:SetVertexColor(color.r, color.g, color.b);
            end
        end
 
        if ( duration > 0 and expirationTime ) then
            if ( SHOW_BUFF_DURATIONS == "1" ) then
                buff.duration:Show();
            else
                buff.duration:Hide();
            end
 
            if ( not buff.timeLeft ) then
                buff.timeLeft = expirationTime - GetTime();
                buff:SetScript("OnUpdate", function(self)
                AuraButton_OnUpdate(self)
                if ( GameTooltip:IsOwned(self) ) then
                GameTooltip:SetUnitAura(PlayerFrame.unit, index, filter)
                GameTooltip:AddLine("\nSpell ID: "..select(11, aura("player", index)))
                GameTooltip:Show()
                end
                end)
            else
                buff.timeLeft = expirationTime - GetTime();
            end        
            buff.expirationTime = expirationTime;   
        else
            buff.duration:Hide();
            if ( buff.timeLeft ) then
                buff:SetScript("OnUpdate", nil);
            end
            buff.timeLeft = nil;
			    buff:SetScript("OnUpdate", function(self)
                if ( GameTooltip:IsOwned(self) ) then
                GameTooltip:SetUnitAura(PlayerFrame.unit, index, filter)
                GameTooltip:AddLine("\nSpell ID: "..select(11, aura("player", index)))
                GameTooltip:Show()
                end
                end)
        end
 
        -- Set Texture
        local icon = _G[buffName.."Icon"];
        icon:SetTexture(texture);
 
        -- Set the number of applications of an aura
        if ( count > 1 ) then
            buff.count:SetText(count);
            buff.count:Show();
        else
            buff.count:Hide();
        end
 
        -- Refresh tooltip
        if ( GameTooltip:IsOwned(buff) ) then
            GameTooltip:SetUnitAura(PlayerFrame.unit, index, filter);
        end

 buff:SetScript("OnEnter", function(self)
 GameTooltip:SetOwner(self)
 if UnitAffectingCombat("player") == true then
 self:RegisterForClicks(nil)
 else
 self:RegisterForClicks("RightButtonUp")
 end
 end)
        --if ( shouldConsolidate  and ShouldShowConsolidatedBuffFrame() ) then       
            --buff.consolidated = true; --TODO: Consider ignoreing these alltogether.
            --buff:Hide();
        --end
    end
    return 1;
end
 
---------------------------------------------------------------------------------------------------------------------------------
end


function BuffBuddy_OnEvent(self, event, arg1, arg2, arg3, arg4, arg5)

if event == "ADDON_LOADED" and arg1 == "BuffBuddy" then
BuffBuddy_Check()
BuffBuddy_CreateOptionsMenu()
BuffBuddy_CreateBuffsOptionsMenu()
BuffBuddy_CreateDebuffsOptionsMenu()
BuffBuddy_FinishOptionsMenu()
BuffBuddy_Initialize()
CreateFrame("FRAME", "BBDebuffFrame", UIParent)
BBDebuffFrame:SetWidth(30)
BBDebuffFrame:SetHeight(30)
BBDebuffFrame:SetPoint("CENTER")
CreateFrame("FRAME", "BBBuffFrame", UIParent)
BBBuffFrame:SetWidth(30)
BBBuffFrame:SetHeight(30)
BBBuffFrame:SetPoint("CENTER")

BuffBuddy_UpdateProfile()
BuffBuddy_UpdateBuffPriority()
BuffBuddy_UpdateDebuffPriority()
BuffBuddy_SetupFrame(BBBuffFrame)
BuffBuddy_SetupFrame(BBDebuffFrame)
loaded = true
BuffBuddy_UpdateUI()
BuffFrame_Update()
print("|cff00dfff"..L["SLASH"].."|r")
end

if event == "PLAYER_REGEN_DISABLED" then
BBBuffFrame:Show()
elseif event == "PLAYER_REGEN_ENABLED" then
BuffBuddy_Show(BBBuffFrame, not(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes))
end

end

function BuffBuddy_Show(frame, value)
if value == true then
frame:Show()
else
frame:Hide()
end
end




function BuffBuddy_SetupFrame(frame) -- My baby. it creates drag frames under the main frame so that when you change the scale, the frame doesnt move around the screen. Also saves positions.
dragframe = CreateFrame("Frame", frame:GetName().."Drag", UIParent)
local relativepoint, _, relativeto, xoff, yoff = frame:GetPoint()
dragframe:SetWidth(frame:GetWidth())
dragframe:SetHeight(frame:GetHeight())
dragframe:SetPoint(relativepoint, UIParent, relativeto, xoff, yoff)
dragframe:SetFrameStrata("MEDIUM")
dragframe:SetToplevel()
frame:ClearAllPoints()
frame:SetParent(dragframe)
frame:SetPoint("CENTER")
frame:SetScript("OnDragStart", function(self)
self:GetParent():StartMoving()
end)
frame:SetScript("OnDragStop", function(self)
local point, relativeto, relativepoint, xoff, yoff = _G[self:GetName().."Drag"]:GetPoint()
BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options[self:GetName().."Drag"] = {point, relativeto, relativepoint, xoff, yoff}
self:GetParent():StopMovingOrSizing()
end)
frame:RegisterForDrag("LeftButton")
frame:EnableMouse(true)
dragframe:SetMovable(true)
end

function BuffBuddy_SetPoint(self)
self:ClearAllPoints()
self:SetPoint(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options[self:GetName()][1], BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options[self:GetName()][4], BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options[self:GetName()][5])
end

function BuffBuddy_PlaceFrames()
if loaded == false then return end
BuffBuddy_SetPoint(BBBuffFrameDrag)
BuffBuddy_SetPoint(BBDebuffFrameDrag)
end

function BuffBuddy_Round(number, decimals)
return tonumber((("%%.%df"):format(decimals)):format(number))
end

function BuffBuddy_UpdateAnchors()
local tbl = BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options

----------------Buffs----------------
if BUFF_ACTUAL_DISPLAY > 0 then
local count, row, newrow = 0, 0, false
local point
for idx = 1, BUFF_ACTUAL_DISPLAY do
local buff, lastbuff = _G["BuffButton"..idx], _G["BuffButton"..idx - 1]
count = count + 1
buff:ClearAllPoints()
if count > tbl.buffperrow then
count = count - tbl.buffperrow
row = row + 1
newrow = true
end
if idx == 1 then
buff:SetPoint("CENTER")

elseif newrow == true then
if tbl.buffnewrowup == true then
buff:SetPoint("BOTTOM", _G["BuffButton"..(1 + (row * tbl.buffperrow) - tbl.buffperrow)], "TOP", 0, tbl.buffverticalspacing)
newrow = false
else
buff:SetPoint("TOP", _G["BuffButton"..(1 + (row * tbl.buffperrow) - tbl.buffperrow)], "BOTTOM", 0, 0 - tbl.buffverticalspacing)
newrow = false
end

else
if tbl.bufflefttoright == true then
buff:SetPoint("LEFT", lastbuff, "RIGHT", tbl.buffhorizontalspacing, 0)
else
buff:SetPoint("RIGHT", lastbuff, "LEFT", 0 - tbl.buffhorizontalspacing, 0)
end

end
end
end

---------------Debuffs---------------
----------------Buffs----------------
if DEBUFF_ACTUAL_DISPLAY > 0 then
local count, row, newrow = 0, 0, false
local point
for idx = 1, DEBUFF_ACTUAL_DISPLAY do
local debuff, lastdebuff = _G["DebuffButton"..idx], _G["DebuffButton"..idx - 1]
count = count + 1
debuff:ClearAllPoints()
if count > tbl.debuffperrow then
count = count - tbl.debuffperrow
row = row + 1
newrow = true
end
if idx == 1 then
debuff:SetPoint("CENTER")

elseif newrow == true then
if tbl.debuffnewrowup == true then
debuff:SetPoint("BOTTOM", _G["DebuffButton"..(1 + (row * tbl.debuffperrow) - tbl.debuffperrow)], "TOP", 0, tbl.debuffverticalspacing)
newrow = false
else
debuff:SetPoint("TOP", _G["DebuffButton"..(1 + (row * tbl.debuffperrow) - tbl.debuffperrow)], "BOTTOM", 0, 0 - tbl.debuffverticalspacing)
newrow = false
end

else
if tbl.debufflefttoright == true then
debuff:SetPoint("LEFT", lastdebuff, "RIGHT", tbl.debuffhorizontalspacing, 0)
else
debuff:SetPoint("RIGHT", lastdebuff, "LEFT", 0 - tbl.debuffhorizontalspacing, 0)
end

end
end
end
end


-----------------------------
function BuffBuddy_MoveFrames()
BuffFrame:UnregisterEvent("UNIT_AURA")
BuffFrame:UnregisterEvent("GROUP_ROSTER_UPDATE")
BuffFrame:UnregisterEvent("PLAYER_SPECIALIZATION_CHANGED")
BBBuffFrame:EnableMouse(true)
BBDebuffFrame:EnableMouse(true)
BuffFrame_Update(true)
BuffButton1:EnableMouse(false)
DebuffButton1:EnableMouse(false)
moving = true
print("|cFF00DFFF"..L["DONT_FORGET_TO_LOCK"].."|r")
end

function BuffBuddy_LockFrames()
BuffFrame:RegisterUnitEvent("UNIT_AURA", "player", "vehicle")
BuffFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
BuffFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
BBBuffFrameDrag:StopMovingOrSizing()
BBBuffFrame:EnableMouse(false)
BBDebuffFrameDrag:StopMovingOrSizing()
BBDebuffFrame:EnableMouse(false)
BuffButton1:EnableMouse(true)
DebuffButton1:EnableMouse(true)
moving = false
BuffBuddy_UpdateUI()
end
 
-----------------------------

function BuffBuddy_UpdateUI()
if moving == true then 
BuffFrame_Update(true)
return 
end
if UnitAffectingCombat("player") == false then
BuffBuddy_Show(BBBuffFrame, not(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes))
BuffBuddy_Show(BBDebuffFrame, not(BuffBuddy_Profiles[BuffBuddy_ActiveProfile].options.hideframes))
end
BuffBuddy_PlaceFrames()
BuffFrame_Update()
end




CreateFrame("Frame", "BuffBuddyEventFrame", UIParent)
BuffBuddyEventFrame:RegisterEvent("ADDON_LOADED")
BuffBuddyEventFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
BuffBuddyEventFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
BuffBuddyEventFrame:SetScript("OnEvent", BuffBuddy_OnEvent)